Name:    libassuan
Summary: GnuPG IPC library
Version: 1.0.4
Release: 1

License: LGPL
Source0: ftp://ftp.gnupg.org/gcrypt/libassuan/libassuan-%{version}.tar.bz2
Source1: ftp://ftp.gnupg.org/gcrypt/libassuan/libassuan-%{version}.tar.bz2.sig
Patch0: libassuan-%{version}-aix.patch
URL:     http://www.gnupg.org/
Group:   System Environment/Libraries
Obsoletes: %{name}-devel < %{version}-%{release}
Provides:  %{name}-devel = %{version}-%{release}
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires: pth-devel

Requires: pth-devel
Requires: /sbin/install-info
Requires: info

%description
This is the IPC library used by GnuPG 1.9/2, GPGME and a few other
packages.

This package contains files needed to develop applications using %{name}.

The library is available as 32-bit and 64-bit.
- If you are compiling a 32-bit program, no special compiler options are
  needed.
- If you are compiling a 64-bit program, you have to compile and link your
  application with "cc -q64" or "gcc -maix64".


%prep
%setup -q
# patch to allow building of both 32-bit and 64-bit shared objects
cd src
cat Makefile.in | sed -e 's|AR = ar|AR = ar -X32_64|' > Makefile.tmp
mv -f Makefile.tmp Makefile.in


%build
# setup environment for 32-bit and 64-bit builds
export AR="ar -X32_64"
export NM="nm -X32_64"

# first build the 64-bit version
export CC="cc -q64"
./configure \
    --prefix=%{_prefix} \
    --infodir=%{_prefix}/info
# patch to include setenv.c in the library which is required for AIX
cd src
patch -s < %{PATCH0}
cd ..
make %{?_smp_mflags}

cd src

CreateExportList -X64 libassuan.exp libassuan.a
${CC} -qmkshrobj libassuan.a -o shr64.o -bE:libassuan.exp
rm -f libassuan.exp libassuan.a

CreateExportList -X64 libassuan-pth.exp libassuan-pth.a
${CC} -qmkshrobj libassuan-pth.a -o pth-shr64.o -bE:libassuan-pth.exp -L/opt/freeware/lib -lpth
rm -f libassuan-pth.exp libassuan-pth.a

mv shr64.o pth-shr64.o ..

cd ..

make distclean

# now build the 32-bit version
export CC="cc"
./configure \
    --prefix=%{_prefix} \
    --infodir=%{_prefix}/info
# patch to include setenv.c in the library which is required for AIX
cd src
patch -s < %{PATCH0}
cd ..
make %{?_smp_mflags}

cd src

CreateExportList libassuan.exp libassuan.a
${CC} -qmkshrobj libassuan.a -o shr.o -bE:libassuan.exp
rm -f libassuan.exp libassuan.a
${AR} -rv libassuan.a shr.o

CreateExportList libassuan-pth.exp libassuan-pth.a
${CC} -qmkshrobj libassuan-pth.a -o shr.o -bE:libassuan-pth.exp -L/opt/freeware/lib -lpth
rm -f libassuan-pth.exp libassuan-pth.a
${AR} -rv libassuan-pth.a shr.o

cd ..

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
${AR} -q src/libassuan.a ./shr64.o
rm -f shr64.o
mv pth-shr64.o shr64.o
${AR} -q src/libassuan-pth.a ./shr64.o


%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
make DESTDIR=$RPM_BUILD_ROOT install

rm -f $RPM_BUILD_ROOT%{_infodir}/dir
gzip -9 $RPM_BUILD_ROOT%{_infodir}/assuan.info


%post
/sbin/install-info %{_infodir}/assuan.info.gz %{_infodir}/dir

%postun
if [ $1 -eq 0 ]; then
    /sbin/install-info --delete %{_infodir}/assuan.info.gz %{_infodir}/dir
fi


%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc AUTHORS ChangeLog COPYING NEWS README THANKS TODO
%{_bindir}/*
%{_includedir}/*
%{_libdir}/lib*.a
%{_datadir}/aclocal/*
%{_infodir}/assuan.info*


%changelog
* Mon Jan 07 2008 Michael Perzl <michael@perzl.org> - 1.0.4-1
- updated to version 1.0.4 and included both 32-bit and 64-bit shared objects

* Sat Oct 06 2007 Michael Perzl <michael@perzl.org> - 1.0.3-1
- first version for AIX V5.1 and higher
